Merge tag 'nfsd-6.7-2' of git://git.kernel.org/pub/scm/linux/kernel/git/cel/linux
[linux-2.6-microblaze.git] / tools / perf / tests / shell / record+probe_libc_inet_pton.sh
1 #!/bin/sh
2 # probe libc's inet_pton & backtrace it with ping
3
4 # Installs a probe on libc's inet_pton function, that will use uprobes,
5 # then use 'perf trace' on a ping to localhost asking for just one packet
6 # with the a backtrace 3 levels deep, check that it is what we expect.
7 # This needs no debuginfo package, all is done using the libc ELF symtab
8 # and the CFI info in the binaries.
9
10 # SPDX-License-Identifier: GPL-2.0
11 # Arnaldo Carvalho de Melo <acme@kernel.org>, 2017
12
13 # shellcheck source=lib/probe.sh
14 . "$(dirname "$0")/lib/probe.sh"
15 # shellcheck source=lib/probe_vfs_getname.sh
16 . "$(dirname "$0")/lib/probe_vfs_getname.sh"
17
18 libc=$(grep -w libc /proc/self/maps | head -1 | sed -r 's/.*[[:space:]](\/.*)/\1/g')
19 nm -Dg $libc 2>/dev/null | grep -F -q inet_pton || exit 254
20
21 event_pattern='probe_libc:inet_pton(\_[[:digit:]]+)?'
22
23 add_libc_inet_pton_event() {
24
25         event_name=$(perf probe -f -x $libc -a inet_pton 2>&1 | tail -n +2 | head -n -5 | \
26                         grep -P -o "$event_pattern(?=[[:space:]]\(on inet_pton in $libc\))")
27
28         if [ $? -ne 0 ] || [ -z "$event_name" ] ; then
29                 printf "FAIL: could not add event\n"
30                 return 1
31         fi
32 }
33
34 trace_libc_inet_pton_backtrace() {
35
36         expected=`mktemp -u /tmp/expected.XXX`
37
38         echo "ping[][0-9 \.:]+$event_name: \([[:xdigit:]]+\)" > $expected
39         echo ".*inet_pton\+0x[[:xdigit:]]+[[:space:]]\($libc|inlined\)$" >> $expected
40         case "$(uname -m)" in
41         s390x)
42                 eventattr='call-graph=dwarf,max-stack=4'
43                 echo "(__GI_)?getaddrinfo\+0x[[:xdigit:]]+[[:space:]]\($libc|inlined\)$" >> $expected
44                 echo "main\+0x[[:xdigit:]]+[[:space:]]\(.*/bin/ping.*\)$" >> $expected
45                 ;;
46         ppc64|ppc64le)
47                 eventattr='max-stack=4'
48                 echo "gaih_inet.*\+0x[[:xdigit:]]+[[:space:]]\($libc\)$" >> $expected
49                 echo "getaddrinfo\+0x[[:xdigit:]]+[[:space:]]\($libc\)$" >> $expected
50                 echo ".*(\+0x[[:xdigit:]]+|\[unknown\])[[:space:]]\(.*/bin/ping.*\)$" >> $expected
51                 ;;
52         *)
53                 eventattr='max-stack=3'
54                 echo ".*(\+0x[[:xdigit:]]+|\[unknown\])[[:space:]]\(.*/bin/ping.*\)$" >> $expected
55                 ;;
56         esac
57
58         perf_data=`mktemp -u /tmp/perf.data.XXX`
59         perf_script=`mktemp -u /tmp/perf.script.XXX`
60
61         # Check presence of libtraceevent support to run perf record
62         skip_no_probe_record_support "$event_name/$eventattr/"
63         [ $? -eq 2 ] && return 2
64
65         perf record -e $event_name/$eventattr/ -o $perf_data ping -6 -c 1 ::1 > /dev/null 2>&1
66         # check if perf data file got created in above step.
67         if [ ! -e $perf_data ]; then
68                 printf "FAIL: perf record failed to create \"%s\" \n" "$perf_data"
69                 return 1
70         fi
71         perf script -i $perf_data | tac | grep -m1 ^ping -B9 | tac > $perf_script
72
73         exec 3<$perf_script
74         exec 4<$expected
75         while read line <&3 && read -r pattern <&4; do
76                 [ -z "$pattern" ] && break
77                 echo $line
78                 echo "$line" | grep -E -q "$pattern"
79                 if [ $? -ne 0 ] ; then
80                         printf "FAIL: expected backtrace entry \"%s\" got \"%s\"\n" "$pattern" "$line"
81                         return 1
82                 fi
83         done
84
85         # If any statements are executed from this point onwards,
86         # the exit code of the last among these will be reflected
87         # in err below. If the exit code is 0, the test will pass
88         # even if the perf script output does not match.
89 }
90
91 delete_libc_inet_pton_event() {
92
93         if [ -n "$event_name" ] ; then
94                 perf probe -q -d $event_name
95         fi
96 }
97
98 # Check for IPv6 interface existence
99 ip a sh lo | grep -F -q inet6 || exit 2
100
101 skip_if_no_perf_probe && \
102 add_libc_inet_pton_event && \
103 trace_libc_inet_pton_backtrace
104 err=$?
105 rm -f ${perf_data} ${perf_script} ${expected}
106 delete_libc_inet_pton_event
107 exit $err